<script type="text/javascript">
$(function() {
    // scroll to edited item and let it highlighted
    if ($hash = window.location.hash) {
        $top = $($hash).offset().top - 100;
        $('html,body').animate({
            scrollTop: $top
        }, '1000', 'swing', function(){
            $($hash).find('td')
                .addClass('operated')
                .click('td', function(){
                    $($hash).find('td').removeClass('operated');
                });
        });
    }

    // send filter
    $('#filter-form').submit(function(e){
        e.preventDefault();

        $filter_target  = $(this).prop('action');
        $filter_key     = $(this).find('#filter').val();
        $filter_module  = $(this).find('#module').val();

        if ($filter_key != '' || $filter_module != '') {
            $filter_key = $filter_key.replace(/[\#\/\?]/,'+');
            $filter_target += '/' + $filter_key;

            if ($filter_module != '') {
                $filter_target += ':' + $filter_module;
            }

            window.location.href = $filter_target;
        }

        return false;
    });

    // popover for module
    $('[data-toggle="popover"').popover({
        container   : 'body',
        placement   : 'right',
        trigger     : 'hover',
        template    : '<div class="popover" role="tooltip"><div class="popover-arrow"></div><div class="popover-content"></div></div>'
    });

    // toggle translation by language
    $('.lang-selector').click(function(){
        $selector   = $(this).find('[type="checkbox"]');
        $lang       = $selector.val();
        if ($selector.is(':checked')) {
            $('.lang-'+$lang).show();
            console.log('show '+$lang);
        } else {
            $('.lang-'+$lang).hide();
            console.log('hide '+$lang);
        }
    });

    // form page - module group state
    module_group_state = function(){
        $module_global = $('#module-global');
        if ($module_global.is(':checked')) {
            $('.module-item').prop('disabled', true);
            $('#modules-group').addClass('disabled');
        } else {
            $('.module-item').prop('disabled', false);
            $('#modules-group').removeClass('disabled');
        }
    };
    // instantiate
    $(function(){module_group_state()});
    // capture
    $('#module-global').click(module_group_state);

    // store-form validator
    $('#store-form').submit(function(e){
        // clear error state before calculate
        $(this).find('div').removeClass('has-error');

        // prepare resources
        $errors         = [];
        $key            = $(this).find('#key');
        $trTH           = $(this).find('#tr-th');
        $trEN           = $(this).find('#tr-en');
        $modules        = $(this).find('.module-item');
        $module_global  = $(this).find('#module-global');

        // key is needed
        if ($key.val().length <= 0) {
            $errors.push($key);
        }

        // translate is required at least one from two
        if ($trTH.val().length <= 0 && $trEN.val().length <= 0) {
            $errors.push($trTH, $trEN);
        }

        // checkbox must be checked at least one
        if (!$module_global.is(':checked') 
            && !$modules.is(':checked')) {
            $errors.push($module_global, $modules);
        }

        // raise errors
        if ($errors.length > 0) {
            e.preventDefault();
            $.each($errors, function(index, $el) {
                $el.closest('div').addClass('has-error');
            });

            return false;
        }

        $(this).find('[type="submit"]').prop('disabled', true);
        return true;
    });

});

</script>